#!/usr/bin/perl
$file = 'C:\Program Files\OpenOffice.org 3'
.'\Basis\share\registry\data\org\openoffice\Office\Math.xcu';
use XML::Simple;
#use Data::Dumper;
use charnames qw/:full/;

sub getprop($$){
    foreach(@{shift()->{prop}}){
    	return $_->{value}{content} if $_->{'oor:name'} ~~ $_[0]
    }
};
sub setprop($$$){
    foreach(@{$_[0]->{prop}}){
    	if ($_->{'oor:name'} ~~ $_[1]){
            $_->{value}{content}=$_[2];
            return;
        }
    };
    push @{$_[0]->{prop}},{'oor:name'=>$_[1],'value'=>{'content'=>$_[2]}}
};

local $/; #slurp files full
open FH, $file;
<FH> =~ /\A(.*?<oor:component-data .*?\n)(.*)(\n<\/oor:component-data.*)\Z/s;
close FH;
($start,$stop)=($1,$3);

$xml = XMLin('<?xml version="1.0" encoding="UTF-8"?><doc>'.$2.'</doc>',
             ForceContent=>1);
#print Dumper($xml);
#<<'COMMENT';
foreach my $char(@{$xml->{node}[1]{node}}){
    if(getprop($char,'Set') eq 'Greek'){
         my $cid = $char->{'oor:name'};
         print " $cid => ";
         if($cid =~ m'lambda'i){$cid =~ tr/Bb//d};
         if($cid eq 'vartheta'){
             $cid = 'GREEK THETA SYMBOL'
         } elsif ($cid eq 'varsigma'){
             $cid = 'GREEK SMALL LETTER FINAL SIGMA'
         } else {
             if($cid eq uc($cid)){$cid = "GREEK CAPITAL LETTER $cid"}
             else{$cid = 'GREEK SMALL LETTER ' . uc ($cid)}
         };
         $cid = charnames::vianame($cid);
         print "$cid\n";
         if(defined $cid){
              setprop($char,'FontFormatId','Id2');
              setprop($char,'Char',$cid)
         }
    }
};

#COMMENT
($file=XMLout($xml))=~s/^<opt>\n|\n*<\/opt>\n*\Z//g;
print $start,$file,$stop;
